\input Head

\section{\tt KFIRLP}

% A short (preferably one-line) description of {\tt MyClass}.

{\tt KFIRLP\/} --- Kaiser window FIR low-pass filter design

\subsection{Description}

% A longer description of what {\tt MyClass} is used for.

{\tt KFIRLP \/} designs low-pass filters using a Kaiser window. The
user specifies the sidelobe height, the cut-off frequency and the
transition zone width. KFIRLP computes the filter order and Kaiser
window parameters that best approaches these requirements, returning
the transfer function as a Sequence. 

\subsection{Operating Instructions}

\subsubsection{Example Usage}

% A verbatim block of example code showing proper usage of {\tt
% MyClass}.

\begin{quote}
\footnotesize
\begin{verbatim}
double fc(0.4);      // pass-band edge (Nyquist frequency units)
double alpha = 20;   // side-lobe height: -20 dB
double df = 0.5;     // transition width (Nyquist frequency units)
KFIRLP lp(fc, alpha, df);
Sequence<double> b;
lp.apply(b);
int order = lp.getOrder(); // order of filter generated
// NOTE: b.size() == order + 1
// NOTE: the getOrder function updates the order of the filter
// this is done automatically in the constuctor and with apply(), 
// however, just after changing alpha and df, the order value will 
// still be whatever it was before alpha or df was changed 
double beta = lp.getBeta();    // Kaiser window beta parameter
double fc = lp.getFc();        // pass-band edge
double df = lp.getDf();        // transition width
double alpha = kp.getAlpha();  // side-lobe height

lp.setAlpha(40);        // sidelobe height -40 dB
// NOTE: This will change both the order and the beta of the window
lp.setFc(0.25);         // change pass-band edge
lp.setDf(0.2);          // change transition zone width
lp.apply(b);            // new filter appropriate to new parameters
\end{verbatim}
\end{quote}

\subsubsection{Options/Defaults}

% A list of options or defaults for public methods or member data of
% {\tt MyClass}. 

None.

\subsection{Exceptions}

\subsubsection{Exceptions Thrown}

% A list of exceptions thrown by {\tt MyClass}.

\begin{itemize}
    \item $f_{c}\leq0$ or $f_{c}\geq1$: {\tt std::domain\_error} 
    (constructors, setFc)
    \item $\alpha\leq0$: {\tt std::domain\_error} (constructor, setAlpha)
    \item $|2*df-1|\geq1$: {\tt std::domain\_error} (constructor, 
    setDf)
\end{itemize}

\subsubsection{Exceptions Handled}

% A list of exceptions handled by {\tt MyClass}.

\subsection{Algorithms}

% A discussion of the algorithms used by {\tt MyClass}.

The filter is designed by windowing with a Kaiser window. The Kaiser 
window parameter is fixed by the sidelobe height in dB (-alpha):
\begin{equation}
\beta=\left\{ 
  \begin{array}{cl}
    0.1102(\alpha -8.7) & \alpha > 50 \\
    0.5843*(\alpha-21)^{0.4}+0.07886*(\alpha-21) & 
    50\leq \alpha > 21 \\
    0 & 21\geq \alpha
  \end{array}
\right. 
\end{equation}
The filter order is determined by $\alpha$ and the transition zone 
width $\Delta f$:
\begin{eqnarray}
    n &=& \max\left({\alpha-7.95\over2.285\pi\Delta f},1\right).
\end{eqnarray}
The transfer function
coefficients $b[k]$  are then given by
\begin{equation}
b[k] = W[k]\mbox{sinc}\left[\pi
  f_c\left(k-\mbox{floor}(N-1/2)\right)\right]
\end{equation}
where $N$ is the filter order, $W[k]$ are the Kaiser window coefficients, and
$f_c$ the cut-off frequency in units of the Nyquist frequency (i.e.,
$0<f_c<1$).

\subsection{Accuracy}

% A discussion of issues related to the accuracy of numerical routines
% used by {\tt MyClass}---e.g., approximations,  argument ranges, etc.


\subsection{Performance}

% A discussion of issues related to the speed (e.g., $O(N\log N)$) of
% computationally demanding routines used by {\tt MyClass}.

\subsection{Testing}

% A description of any test code/test classes that were used to test
% {\tt MyClass}. 

{\tt KFIRLP\/} is tested by the program {\tt tKFIRLP.} Checks include
\begin{itemize}
\item  Nominal initialization check 
\item Nominal values check (against {\tt Matlab\/} generated data 
\item  Test the copy constructor and assignment operators 
\item  Nominal check of mutators and accessors 
\item Test to check invalid arguments are not accepted in the
  constructors or mutators  
\end{itemize}

\subsection{Notes}

% Miscellaneous notes about {\tt MyClass} that do not appear
% elsewhere, things that remain to be done, etc.  

\subsection{See Also}

% A list of derived classes, base classes, etc.\ closely related to
% {\tt MyClass}. 

\begin{itemize}
    \item KaiserWindow
    \item FIRLP
\end{itemize}

\subsection{References}

% A list of references for any algorithms, etc.\ used by {\tt
% MyClass}. 

\input Tail

%%% Local Variables: 
%%% mode: latex
%%% TeX-master: "datacondAPI"
%%% End: 
